## ros-melodic-knowledge-representation 0.9.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(knowledge_representation)

set(CMAKE_CXX_STANDARD 11)

find_package(catkin REQUIRED COMPONENTS
        roslint
        )
find_package(Boost REQUIRED COMPONENTS python)

find_package(PythonLibs 2.7 REQUIRED)

find_package(PostgreSQL)

find_library(libpqxx NAMES pqxx)

find_library(mysqlcppconn NAMES libmysqlcppconn8.so)

# Check to see if we have the right version of MySQL Cpp Connector installed
if(POSTGRESQL_FOUND OR libpqxx)
    set(POSTGRES_AVAILABLE true)
    set(DB_INCLUDES ${PostgreSQL_INCLUDE_DIRS})
    set(DB_LIBS ${PostgreSQL_LIBRARIES} ${libpqxx})
    set(EXPORTED_DEPEND "")
    add_definitions(-DUSE_POSTGRESQL)
elseif(mysqlcppconn)
    message(WARNING "PostgreSQL not found. Using incomplete MySQL implementation.")
    set(MYSQL_AVAILABLE true)
    find_path(DB_INCLUDES mysqlx/xdevapi.h HINT /usr/local/mysql/connector-c++-8.0/include)
    set(mysqlcppconn_INCLUDE_DIRS ${DB_INCLUDES})
    set(mysqlcppconn_LIBRARIES ${mysqlcppconn})
    set(DB_LIBS ${mysqlcppconn})
    set(EXPORTED_DEPEND mysqlcppconn)
    add_definitions(-DUSE_MYSQL)
else()
    message(FATAL_ERROR "Neither MySQL nor PostgreSQL found. Please install one.")
endif()

catkin_python_setup()

catkin_package(
        INCLUDE_DIRS include
        LIBRARIES knowledge_rep ${DB_LIBS}
        CATKIN_DEPENDS
        DEPENDS ${EXPORTED_DEPEND}
)

include_directories(
        ${Boost_INCLUDE_DIRS}
        ${catkin_INCLUDE_DIRS}
        ${DB_INCLUDES}
        include
        ${PYTHON_INCLUDE_DIRS}
)


if ("${MYSQL_AVAILABLE}" OR "${POSTGRES_AVAILABLE}")
    set(INTERFACE_HEADER_PATH ${PROJECT_SOURCE_DIR}/include/knowledge_representation/LongTermMemoryConduit.h)
if (MYSQL_AVAILABLE)
    set(DB_SOURCES src/libknowledge_rep/LongTermMemoryConduitMySQL.cpp)
    set(DB_BACKEND MySQL)

elseif (POSTGRES_AVAILABLE)
    set(DB_SOURCES src/libknowledge_rep/LongTermMemoryConduitPostgreSQL.cpp)
    set(DB_BACKEND PostgreSQL)

endif()

# This header file imports the correct backend. Lets library users avoid
# depending on a particular backend
configure_file(${INTERFACE_HEADER_PATH}.in ${INTERFACE_HEADER_PATH})
add_library(knowledge_rep
        ${DB_SOURCES}
        src/libknowledge_rep/convenience.cpp
        )

target_link_libraries(knowledge_rep ${DB_LIBS} ${catkin_LIBRARIES})

add_library(_libknowledge_rep_wrapper_cpp src/libknowledge_rep/python_wrapper.cpp)
target_link_libraries(_libknowledge_rep_wrapper_cpp
        knowledge_rep
        ${DB_LIBS}
        ${Boost_LIBRARIES}
        ${catkin_LIBRARIES})

set_target_properties(_libknowledge_rep_wrapper_cpp PROPERTIES
        PREFIX ""
        LIBRARY_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_PYTHON_DESTINATION}
        )

catkin_add_env_hooks(${PROJECT_NAME} SHELLS bash zsh DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/env-hooks)

### INSTALL

install(TARGETS knowledge_rep _libknowledge_rep_wrapper_cpp
        ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
        RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})

catkin_install_python(PROGRAMS scripts/ikr scripts/populate_with_knowledge scripts/populate_with_map scripts/show_me
        DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

install(PROGRAMS scripts/configure_postgresql.sh
        DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}/scripts)

install(DIRECTORY include/${PROJECT_NAME}/
        DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(DIRECTORY sql/
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/sql)

### LINTING

file(GLOB_RECURSE ${PROJECT_NAME}_CPP_SRC
        RELATIVE ${PROJECT_SOURCE_DIR} src/lib${PROJECT_NAME}/*.cpp src/libknowledge_rep/*.h include/${PROJECT_NAME}/*.h test/*.cpp)
set(ROSLINT_CPP_OPTS "--filter=-legal/copyright,-build/header_guard,-runtime/references,-build/c++11,-whitespace/braces")
roslint_cpp(${${PROJECT_NAME}_CPP_SRC})

# Lint Python modules for PEP8 compatibility
file(GLOB_RECURSE ${PROJECT_NAME}_PY_SCRIPTS
        RELATIVE ${PROJECT_SOURCE_DIR} scripts/populate_* scripts/test_ltmc scripts/dump_to_owl)

# List FILTER isn't supported in 16.04's CMake
# list(FILTER ${PROJECT_NAME}_PY_SCRIPTS EXCLUDE REGEX ".*.sh")
file(GLOB_RECURSE ${PROJECT_NAME}_PY_SRC
        RELATIVE ${PROJECT_SOURCE_DIR} src/${PROJECT_NAME}/*.py)
set(ROSLINT_PYTHON_OPTS "--max-line-length=120")
roslint_python(${${PROJECT_NAME}_PY_SCRIPTS})
roslint_python(${${PROJECT_NAME}_PY_SRC})

### TEST TARGETS
if(CATKIN_ENABLE_TESTING)
    catkin_add_gtest(test_ltmc test/ltmc.cpp test/entity.cpp test/concept_instance.cpp test/map_types.cpp)
    target_link_libraries(test_ltmc knowledge_rep ${catkin_LIBRARIES})
    add_dependencies(test_ltmc _libknowledge_rep_wrapper_cpp)

    catkin_add_nosetests(test/ltmc.py)
    catkin_add_nosetests(test/loaders.py)
endif()

endif ()

### DOCS
find_package(Doxygen)
if(DOXYGEN_FOUND)

    set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/doc/Doxyfile)

    configure_file(${doxyfile_in} ${doxyfile} @ONLY)

    add_custom_target(doc
            COMMAND ${CMAKE_COMMAND} -E echo_append "Building API Documentation..."
            COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/doc
            COMMAND ${CMAKE_COMMAND} -E echo_append "API Documentation built in ${CMAKE_CURRENT_SOURCE_DIR}/doc"
            VERBATIM)
endif()

=== debian/changelog ===
ros-melodic-knowledge-representation (0.9.1-1stretch) stretch; urgency=high

  * Update YAML knowledge_loader
  * Support passing multiple maps to the map loader
  * Update rosdeps for Noetic

 -- Nick Walker <nswalker@cs.washington.edu>  Thu, 23 Jul 2020 07:00:00 -0000

ros-melodic-knowledge-representation (0.9.0-1stretch) stretch; urgency=high

  * Initial release

 -- Nick Walker <nswalker@cs.washington.edu>  Tue, 07 Jul 2020 07:00:00 -0000

=== debian/control ===
Source: ros-melodic-knowledge-representation
Section: misc
Priority: optional
Maintainer: Nick Walker <nswalker@cs.washington.edu>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libpqxx-4.0v5, libpqxx-dev, postgresql, postgresql-contrib, python-dev, ros-melodic-catkin, ros-melodic-roslint, ros-melodic-rosunit
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-knowledge-representation
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libpqxx-4.0v5, libpqxx-dev, postgresql, postgresql-contrib, python-dev, python-imaging, python3-pil
Description: APIs for storing and querying information about the world.
 Provides C++ and Python API's to make getting facts in and out easy (while still exposing a full SQL interface). Supports PostgreSQL and MySQL backends.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-knowledge-representation//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install

## ros-melodic-knowledge-representation 0.9.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8.3)
+cmake_minimum_required(VERSION 3.0.2)
 project(knowledge_representation)
 
 set(CMAKE_CXX_STANDARD 11)
@@ -8,7 +8,11 @@
         )
 find_package(Boost REQUIRED COMPONENTS python)
 
+if($ENV{ROS_DISTRO} STREQUAL "kinetic" OR $ENV{ROS_DISTRO} STREQUAL "melodic")
 find_package(PythonLibs 2.7 REQUIRED)
+else()
+    find_package(PythonLibs 3.8 REQUIRED)
+endif()
 
 find_package(PostgreSQL)
 
@@ -97,7 +101,7 @@
         LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
         RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})
 
-catkin_install_python(PROGRAMS scripts/ikr scripts/populate_with_knowledge scripts/populate_with_map scripts/show_me
+catkin_install_python(PROGRAMS scripts/ikr scripts/populate_with_knowledge scripts/populate_with_map scripts/show_me scripts/create_door_pgm
         DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})
 
 install(PROGRAMS scripts/configure_postgresql.sh

=== debian/changelog ===
ros-melodic-knowledge-representation (0.9.4-1bionic) bionic; urgency=high

  * Add lock capability to LTMC
  * Improve support for SVG transforms in map annotations
  * Document map annotation process
  * Improve example annotated map
  * Contributors: Nick Walker, Yuqian Jiang, Tobias Fischer

 -- Nick Walker <nswalker@cs.washington.edu>  Mon, 16 Aug 2021 07:00:00 -0000

ros-melodic-knowledge-representation (0.9.3-1bionic) bionic; urgency=high

  * Add door type
  * Add script for making a PGM that has annotated doors as obstacles
  * Update annotation loader to look for groups that look like door annotations
  * Fix "contained" queries and use in show_me
  * Minor documentation improvements
  * Support "instance_of" in knowledge loader
  * Fix API for SELECT queries on entity_attributes tables
  * Contributors: Nick Walker, Yuqian Jiang

 -- Nick Walker <nswalker@cs.washington.edu>  Sat, 06 Feb 2021 08:00:00 -0000

ros-melodic-knowledge-representation (0.9.2-1bionic) bionic; urgency=high

  * Fix errant Python2 style print
  * Build Python3 bindings for new distributions
  * Conditional dependencies for Python2/Python3 image library
  * Use setuptools always
  * Bump CMake version to avoid CMP0048
  * Contributors: Nick Walker, Shane Loretz

 -- Nick Walker <nswalker@cs.washington.edu>  Sun, 26 Jul 2020 07:00:00 -0000

ros-melodic-knowledge-representation (0.9.1-1bionic) bionic; urgency=high

  * Update YAML knowledge_loader
  * Support passing multiple maps to the map loader
  * Update rosdeps for Noetic

 -- Nick Walker <nswalker@cs.washington.edu>  Thu, 23 Jul 2020 07:00:00 -0000

ros-melodic-knowledge-representation (0.9.0-1bionic) bionic; urgency=high

  * Initial release

 -- Nick Walker <nswalker@cs.washington.edu>  Tue, 07 Jul 2020 07:00:00 -0000

=== debian/control ===
Source: ros-melodic-knowledge-representation
Section: misc
Priority: optional
Maintainer: Nick Walker <nswalker@cs.washington.edu>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libpqxx-4.0v5, libpqxx-dev, postgresql, postgresql-contrib, python-dev, python-setuptools, ros-melodic-catkin, ros-melodic-roslint, ros-melodic-rosunit
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-knowledge-representation
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libpqxx-4.0v5, libpqxx-dev, postgresql, postgresql-contrib, python-dev, python-pil
Description: APIs for storing and querying information about the world.
 Provides C++ and Python API's to make getting facts in and out easy (while still exposing a full SQL interface). Supports PostgreSQL and MySQL backends.
